/*
 * iAirZoning
 * Copyright 2020 José Antonio Jiménez Campos
 */

#ifndef __IAIRZONING_GATE_CONTROL_H__
#define __IAIRZONING_GATE_CONTROL_H__

#include "mcp_23017.h"

/*
 Función que recibe la orden de abrir o cerrar una compuerta, y decide si hay que
 activar o no los actuadores correspondientes en base al estado actual
 @param homekit_thermostat      Termostato sobre el cual se va a abrir o cerrar la compuerta
 @param target_status           Estado final que debe tener la compuerta (false: cerrada, true: abierta)
 */
void gate_open_close(homekit_thermostat_t* homekit_thermostat, const bool target_status);

#endif  // __IAIRZONING_GATE_CONTROL_H__
