/*
* iAirZoning
* Copyright 2020 José Antonio Jiménez Campos
*/

#ifndef __IAIRZONING_TYPES_H__
#define __IAIRZONING_TYPES_H__

#include <etstimer.h>

/*
 Estructura de datos para guardar toda la información de cada termostato
 */
typedef struct _homekit_thermostat {
    uint8_t room;
    uint8_t sensor_gpio;
    uint8_t sensor_errors_count;
    
    uint8_t open_mcp_gpio;
    uint8_t close_mcp_gpio;
    uint8_t gate_status;
    uint16_t time_open_close_ms;
    
    uint8_t mode;
    ETSTimer update_th_timer;
    TaskHandle_t gate_task_handle;
    
    float temp_offset;
    float hum_offset;
    
    homekit_characteristic_t *active;
    homekit_characteristic_t *current_temp;
    homekit_characteristic_t *display_units;
    homekit_characteristic_t *current_state;
    homekit_characteristic_t *target_state;
    homekit_characteristic_t *target_heating_temp;
    homekit_characteristic_t *target_cooling_temp;
    
    homekit_characteristic_t *current_hum;
    
    struct _homekit_thermostat *next;
} homekit_thermostat_t;

#endif // __IAIRZONING_TYPES_H__
